package com.cloupia.feature.foo.accounts;

import javax.jdo.annotations.NotPersistent;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.xml.bind.annotation.XmlRootElement;

import com.cloupia.feature.foo.accounts.forms.UsersForm;
import com.cloupia.lib.easyui.annotations.NonReportField;
import com.cloupia.lib.easyui.annotations.ReportField;
import com.cloupia.model.cIM.FormFieldDefinition;
import com.cloupia.service.cIM.inframgr.TaskConfigIf;
import com.cloupia.service.cIM.inframgr.customactions.CustomActionIf;
import com.cloupia.service.cIM.inframgr.forms.wizard.FormField;
import com.cloupia.service.cIM.inframgr.forms.wizard.FormManagedList;
import com.cloupia.service.cIM.tree.MoReference;
import com.cloupia.service.cIM.tree.MoResourceIf;


/**
 * This is dummy class for POJO based approach for API form with FormManagedList. 
 * For real implementation similar POJO based approach can be refer.
 *
 */
@XmlRootElement(name = "FooAccount")
@PersistenceCapable(detachable = "true")
public class FormManagedListDummyAccount implements TaskConfigIf{
	
	public static final String HANDLER_NAME  = "Create Dummy Account";
    public static final String HANDLER_LABEL = "Create Dummy Account";
    
    public static final String MODIFY_HANDLER_NAME  = "Modify Dummy Account";
    public static final String MODIFY_HANDLER_LABEL = "Modify Dummy Account";
    
    @Persistent
    private long               actionId;
    @Persistent
    private long               configEntryId;
	
	@MoReference(path = "FooAccount.ID", key = true)
	@FormField(label = "Account Name", help = "Account Name", mandatory = true)
	@ReportField(label="Account Name")
	@Persistent
	private String accountName;
	
	@FormField(label = "Status", help = "Status", mandatory = true)
	@ReportField(label="Status")
	@Persistent
 	private String status;
	@FormField(label = "IP Address", help = "IP Address", mandatory = true)
	@ReportField(label="IP Address")
	@Persistent
 	private String ip;
	
	@NotPersistent
    @FormField(label = "Users" , help = "Select users", type = FormFieldDefinition.FIELD_TYPE_TABULAR_NO_CHECKBOX, formManagedTable = true, addEntryForm = "default", editEntryForm = "default", deleteEntryForm = "default", rbid = "foo.accounts.form.DummyAccount.field.usersList")
    @NonReportField
    private FormManagedList<UsersForm>     usersList    = new FormManagedList<UsersForm>(
                                                                                  UsersForm.class);


	public String getAccountName() {
		// TODO Auto-generated method stub
		return accountName;
	}

	public void setAccountName(String accountName) {
		// TODO Auto-generated method stub
		this.accountName = accountName;
	}
	
	

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getIp() {
		return ip;
	}

	public void setIp(String ip) {
		this.ip = ip;
	}
	

    public String getDisplayLabel(){
    	return HANDLER_LABEL;
    }

	public long getActionId() {
		return actionId;
	}

	public void setActionId(long actionId) {
		this.actionId = actionId;
	}

	public long getConfigEntryId() {
		return configEntryId;
	}

	public void setConfigEntryId(long configEntryId) {
		this.configEntryId = configEntryId;
	}

	public FormManagedList<UsersForm> getUsersList() {
		
		FormManagedList<UsersForm> list = new FormManagedList<UsersForm>();
		
		UsersForm theUser = new UsersForm();
		theUser.setFirstName("John");
		theUser.setLastName("Doe");
		theUser.setEmailAddress("johndoe@abc.com");
		list.addEntry(theUser);
		theUser = new UsersForm();
		theUser.setFirstName("Peter");
		theUser.setLastName("Pan");
		theUser.setEmailAddress("peterpan@abc.com");
		list.addEntry(theUser);
		usersList = list;
		return usersList;
	}

	public void setUsersList(FormManagedList<UsersForm> usersList) {
		FormManagedList<UsersForm> list = new FormManagedList<UsersForm>();

		UsersForm theUser = new UsersForm();
		theUser.setFirstName("John");
		theUser.setLastName("Doe");
		theUser.setEmailAddress("johndoe@abc.com");
		list.addEntry(theUser);
		theUser = new UsersForm();
		theUser.setFirstName("Peter");
		theUser.setLastName("Pan");
		theUser.setEmailAddress("peterpan@abc.com");
		list.addEntry(theUser);
		//usersList = list;
		this.usersList = list;
	}

	
}
