package com.cloupia.feature.foo.api.config;

import javax.jdo.annotations.Column;
import javax.jdo.annotations.NotPersistent;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.xml.bind.annotation.XmlRootElement;

import com.cisco.cuic.api.client.WorkflowInputFieldTypeDeclaration;
import com.cloupia.feature.foo.accounts.forms.UsersForm;
import com.cloupia.feature.foo.accounts.forms.UsersFormValidator;
import com.cloupia.lib.easyui.annotations.NonReportField;
import com.cloupia.lib.easyui.annotations.ReportField;
import com.cloupia.model.cIM.FormFieldDefinition;
import com.cloupia.service.cIM.inframgr.TaskConfigIf;
import com.cloupia.service.cIM.inframgr.customactions.UserInputField;
import com.cloupia.service.cIM.inframgr.forms.wizard.FormField;
import com.cloupia.service.cIM.inframgr.forms.wizard.FormManagedList;
import com.cloupia.service.cIM.tree.MoReference;

@XmlRootElement(name = "FooAccountWithUsers")
@PersistenceCapable(detachable = "true", table="foo_dummyaccount_wf")
public class CreateDummyAccountWithUsersConfig  implements TaskConfigIf{
	

	public static final String HANDLER_NAME  = "Create Dummy Account with Users";
    public static final String HANDLER_LABEL = "Create Dummy Account with Users";
    
   
    @Persistent
    private long               actionId;
    @Persistent
    private long               configEntryId;
	
	@MoReference(path = "FooAccount.ID", key = true)
	@FormField(label = "Account Name", help = "Account Name", mandatory = true)
	@ReportField(label="Account Name")
	@Persistent
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	private String accountName;
	
	@FormField(label = "Status", help = "Status", mandatory = true)
	@ReportField(label="Status")
	@Persistent
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
 	private String status;
	
	@FormField(label = "IP Address", help = "IP Address", mandatory = true)
	@ReportField(label="IP Address")
	@Persistent
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
 	private String ip;
	
	 @Persistent
		@Column(jdbcType = "CLOB")
		@NonReportField
		private String   usersJSONData;

	public String getUsersJSONData() {
		return usersJSONData;
	}

	public void setUsersJSONData(String usersJSONData) {
		this.usersJSONData = usersJSONData;
	}

	@NotPersistent
    @FormField(label = "Users" , help = "Select users", type = FormFieldDefinition.FIELD_TYPE_TABULAR_NO_CHECKBOX, formManagedTable = true, addEntryForm = "default", editEntryForm = "default", deleteEntryForm = "default")
    @NonReportField
    @UserInputField(type = "usersListType")
    private FormManagedList<UsersForm>   usersList    = new FormManagedList<UsersForm>(
                                                                                  UsersForm.class, new UsersFormValidator());


	public String getAccountName() {
		return accountName;
	}

	public void setAccountName(String accountName) {
		this.accountName = accountName;
	}
	
	

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getIp() {
		return ip;
	}

	public void setIp(String ip) {
		this.ip = ip;
	}
	

    public String getDisplayLabel(){
    	return HANDLER_LABEL;
    }

	public long getActionId() {
		return actionId;
	}

	public void setActionId(long actionId) {
		this.actionId = actionId;
	}

	public long getConfigEntryId() {
		return configEntryId;
	}

	public void setConfigEntryId(long configEntryId) {
		this.configEntryId = configEntryId;
	}

	public FormManagedList<UsersForm> getUsersList() {
		
		FormManagedList<UsersForm> list = new FormManagedList<UsersForm>();
		
		UsersForm theUser = new UsersForm();
		theUser.setFirstName("John");
		theUser.setLastName("Doe");
		theUser.setEmailAddress("johndoe@abc.com");
		list.addEntry(theUser);
		theUser = new UsersForm();
		theUser.setFirstName("Peter");
		theUser.setLastName("Pan");
		theUser.setEmailAddress("peterpan@abc.com");
		list.addEntry(theUser);
		usersList = list;
		
		

		return usersList;
	}

	public void setUsersList(FormManagedList<UsersForm> usersList) {
		FormManagedList<UsersForm> list = new FormManagedList<UsersForm>();

		UsersForm theUser = new UsersForm();
		theUser.setFirstName("John");
		theUser.setLastName("Doe");
		theUser.setEmailAddress("johndoe@abc.com");
		list.addEntry(theUser);
		theUser = new UsersForm();
		theUser.setFirstName("Peter");
		theUser.setLastName("Pan");
		theUser.setEmailAddress("peterpan@abc.com");
		list.addEntry(theUser);		//usersList = list;
		this.usersList = usersList;
	}

}
