package com.cloupia.feature.foo.api.config;

import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

import com.cloupia.lib.easyui.annotations.ReportField;
import com.cloupia.model.cIM.FormFieldDefinition;
import com.cloupia.service.cIM.inframgr.TaskConfigIf;
import com.cloupia.service.cIM.inframgr.customactions.UserInputField;
import com.cloupia.service.cIM.inframgr.customactions.WorkflowInputFieldTypeDeclaration;
import com.cloupia.service.cIM.inframgr.forms.wizard.FormField;
import com.cloupia.service.cIM.tree.MoReference;


/**
 * This is dummy class for POJO based approach for Account Type implementation. 
 * Data populating from DummyAccountData for this account.
 * For real implementation similar POJO based approach can be refer.
 * 
 *
 */
/*
 * XmlRootElement annotation is added to support XML REST APIs.
 * It is mandatory annotaion for REST API payload using root element framework will identify  config.
 * name is mandatory for XmlRootElement annotation.
 * If there is no getter setter method available framework will ignore part of payload.
 */
@XmlRootElement(name = "FooAccount")
@PersistenceCapable(detachable = "true", table = "foo_createdummyaccount")
public class DummyAccountCreateConfig implements TaskConfigIf{
	
	public static final String HANDLER_NAME  = "Create Dummy Account";
    public static final String HANDLER_LABEL = "Create Dummy Account";
      
    @Persistent
    private long               actionId;
    @Persistent
    private long               configEntryId;
	/*
	 * MoReference annotation is used to identify the resource for the URL.
	 * It contains two attributes "path" and "key".
	 * Path attribute is for unique id of resource.It is mandatory. 
	 * key attribute is not mandatory. if key is true framework will identify as primary for the requested URL
	 * 
	 */
	@MoReference(path = "FooAccount.ID", key = true)
	@FormField(label = "Account Name", help = "Account Name", mandatory = true)
	@ReportField(label="Account Name")
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	@Persistent
	private String accountName;
	
	@FormField(label = "Status", help = "Status", mandatory = true)
	@ReportField(label="Status")
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	@Persistent
 	private String status;
	@FormField(label = "IP Address", help = "IP Address", mandatory = true)
	@ReportField(label="IP Address")
	@Persistent
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
 	private String ip;
	
	@FormField(label = "Enable Description", type = FormFieldDefinition.FIELD_TYPE_BOOLEAN)
	@ReportField(label="Enable Description")
	@Persistent
    private boolean enableDesc;
	
	@FormField(label = "Description", help = "Description", mandatory = false, hidden=true)
	@ReportField(label="Description")
	@Persistent
	private String desc;

	public DummyAccountCreateConfig(){}
	
	public String getAccountName() {
		// TODO Auto-generated method stub
		return accountName;
	}

	public void setAccountName(String accountName) {
		// TODO Auto-generated method stub
		this.accountName = accountName;
	}
	
	

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getIp() {
		return ip;
	}

	public void setIp(String ip) {
		this.ip = ip;
	}
	

    public String getDisplayLabel(){
    	return HANDLER_LABEL;
    }
    @XmlTransient
	public long getActionId() {
		return actionId;
	}

	public void setActionId(long actionId) {
		this.actionId = actionId;
	}
	@XmlTransient
	public long getConfigEntryId() {
		return configEntryId;
	}

	public void setConfigEntryId(long configEntryId) {
		this.configEntryId = configEntryId;
	}

	public String getDesc() {
		return desc;
	}

	public void setDesc(String desc) {
		this.desc = desc;
	}

	public boolean isEnableDesc() {
		return enableDesc;
	}

	public void setEnableDesc(boolean enableDesc) {
		this.enableDesc = enableDesc;
	}

	
}
