package com.cloupia.feature.foo.api.config;

import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.xml.bind.annotation.XmlRootElement;

import com.cloupia.feature.foo.lovs.DummyAccountLOVProvider;
import com.cloupia.model.cIM.FormFieldDefinition;
import com.cloupia.service.cIM.inframgr.TaskConfigIf;
import com.cloupia.service.cIM.inframgr.customactions.UserInputField;
import com.cloupia.service.cIM.inframgr.customactions.WorkflowInputFieldTypeDeclaration;
import com.cloupia.service.cIM.inframgr.forms.wizard.FieldValidation;
import com.cloupia.service.cIM.inframgr.forms.wizard.FormController;
import com.cloupia.service.cIM.inframgr.forms.wizard.FormField;
import com.cloupia.service.cIM.inframgr.forms.wizard.HideFieldOnCondition;

@FormController(value="com.cloupia.feature.foo.api.config.controller.DummyAccountSpecificConfigController")
@XmlRootElement(name = "SampleAccount")
@PersistenceCapable(detachable = "true", table = "dummy_account_device")
public class DummyAccountSpecificConfig implements TaskConfigIf{
	public static final String HANDLER_NAME  = "Dummy Account Controller";
    public static final String HANDLER_LABEL = "Dummy Account Controller";
      
    public static final String TYPE_STANDARD = "0";
	public static final String TYPE_ADVANCED = "1";
	public static final String TYPE_CUSTOM =  "2";
	
    @Persistent
    private long               actionId;
    @Persistent
    private long               configEntryId;
    
    private int dummyModelID;

	@Persistent
	@FormField(label = "Dummy Controller Name", help = "Dummy Controller Name", type = FormFieldDefinition.FIELD_TYPE_TEXT, mandatory = true)
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	private String dummyControllerName;

	@Persistent
	@FormField(label = "Dummy Model Description", help = "Dummy Model Description", type = FormFieldDefinition.FIELD_TYPE_TEXT)
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	private String dummyModelDescription;

	@Persistent
	@FormField(label = "Dummy Model Type", type = FormFieldDefinition.FIELD_TYPE_EMBEDDED_LOV, validate = true, mandatory = true,lovProvider=DummyAccountLOVProvider.DUMMY_LOV_PROVIDER)
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	private String dummyModelType=TYPE_STANDARD;
	
	@Persistent
	@HideFieldOnCondition(field = "dummyModelType", op = FieldValidation.OP_IN, values={TYPE_STANDARD,TYPE_CUSTOM})
	@FormField(label = "Advanced Dummy Model", help = "Advanced Dummy Model", type = FormFieldDefinition.FIELD_TYPE_TEXT,multiline=true,maxLength=80384)
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	private String advanceDummyModel;
	
	@Persistent
	@HideFieldOnCondition(field = "dummyModelType", op = FieldValidation.OP_IN, values={TYPE_ADVANCED})
	@FormField(label = "Charge Duration", type = FormFieldDefinition.FIELD_TYPE_EMBEDDED_LOV)
	@UserInputField(type = WorkflowInputFieldTypeDeclaration.GENERIC_TEXT)
	private String chargeDuration;
	
    
	@Override
	public long getActionId() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public long getConfigEntryId() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public String getDisplayLabel() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setActionId(long arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void setConfigEntryId(long arg0) {
		// TODO Auto-generated method stub
		
	}

	public int getDummyModelID() {
		return dummyModelID;
	}

	public void setDummyModelID(int dummyModelID) {
		this.dummyModelID = dummyModelID;
	}

	public String getDummyControllerName() {
		return dummyControllerName;
	}

	public void setDummyControllerName(String dummyControllerName) {
		this.dummyControllerName = dummyControllerName;
	}

	public String getDummyModelDescription() {
		return dummyModelDescription;
	}

	public void setDummyModelDescription(String dummyModelDescription) {
		this.dummyModelDescription = dummyModelDescription;
	}

	public String getDummyModelType() {
		return dummyModelType;
	}

	public void setDummyModelType(String dummyModelType) {
		this.dummyModelType = dummyModelType;
	}

	public String getAdvanceDummyModel() {
		return advanceDummyModel;
	}

	public void setAdvanceDummyModel(String advanceDummyModel) {
		this.advanceDummyModel = advanceDummyModel;
	}

	public String getChargeDuration() {
		return chargeDuration;
	}

	public void setChargeDuration(String chargeDuration) {
		this.chargeDuration = chargeDuration;
	}

	
	


}
