package com.cloupia.feature.foo.api.config;

import org.apache.log4j.Logger;

import com.cloupia.feature.foo.tasks.FooTaskContextConfigController;
import com.cloupia.model.cIM.FormLOVPair;
import com.cloupia.model.cIM.ReportContext;
import com.cloupia.service.cIM.inframgr.forms.wizard.AbstractObjectUIController;
import com.cloupia.service.cIM.inframgr.forms.wizard.Page;

public class DummyAccountSpecificConfigController extends AbstractObjectUIController {

	private static Logger logger = Logger.getLogger(DummyAccountSpecificConfigController.class);
	@Override
    public void beforeMarshall(Page page, String id, ReportContext context, Object pojo) throws Exception
    {
		DummyAccountSpecificConfig config = (DummyAccountSpecificConfig) pojo;
		logger.info(" before Marshall ");		
		
		page.setEmbeddedLOVs(id + ".chargeDuration", getDurationLOV());
    }
	@Override
	public void afterMarshall(Page page, String id, ReportContext context, Object pojo) throws Exception {
		DummyAccountSpecificConfig config = (DummyAccountSpecificConfig) pojo;

		String cpuChargeUnit = "";

		String costModelType = page.getValue(id + ".costModelType");
		if (null != costModelType && (costModelType.equals(DummyAccountSpecificConfig.TYPE_STANDARD)
				|| costModelType.equals(DummyAccountSpecificConfig.TYPE_CUSTOM))) {

			if (page.isValidateSet(id + ".cpuChargeUnit")) {
				//cpuChargeUnit = page.getValue(id + ".cpuChargeUnit");
			} else {
				//cpuChargeUnit = config.getCpuChargeUnit();
			}
			
		}

	}
	@Override
	public void afterUnmarshall(Page page, String id, ReportContext context, Object pojo) throws Exception {
		 DummyAccountSpecificConfig config = (DummyAccountSpecificConfig) pojo;

	     	if (page.isPageSubmitted())
	     	{   
	     		String name = config.getDummyControllerName();
	     		if(name == null)
	     		{
	     			throw new Exception("Name should not be empty");
	     		}
	     	}
	}
	@Override
	public void beforeUnmarshall(Page page, String id, ReportContext context, Object pojo) throws Exception {
		
	}
	
	
	public static FormLOVPair[] getDurationLOV()
    {
        FormLOVPair[] keyPair = new FormLOVPair[] { new FormLOVPair("Hourly", "0"),
                
                new FormLOVPair("Weekly", "1") };

        return keyPair;
    }
	
	
}

