package com.cloupia.feature.foo.api.tasks;


import org.apache.log4j.Logger;
import java.util.List;
import com.cisco.cuic.api.client.WFFieldTypeConstants;
import com.cloupia.feature.foo.api.config.CreateDummyAccountWithUsersConfig;
import com.cloupia.feature.foo.constants.FooConstants;
import com.cloupia.fw.objstore.ObjStore;
import com.cloupia.fw.objstore.ObjStoreHelper;
import com.cloupia.service.cIM.inframgr.AbstractTask;
import com.cloupia.service.cIM.inframgr.TaskConfigIf;
import com.cloupia.service.cIM.inframgr.TaskOutputDefinition;
import com.cloupia.service.cIM.inframgr.customactions.CustomActionLogger;
import com.cloupia.service.cIM.inframgr.customactions.CustomActionTriggerContext;

public class CreateDummyAccountTask extends AbstractTask
{

    static Logger logger = Logger.getLogger(CreateDummyAccountTask.class);
    
    @Override
    public void executeCustomAction(CustomActionTriggerContext context, CustomActionLogger actionLogger) throws Exception
    {
    	logger.info("inside CreateDummyAccountTask execute custom action method");
    	CreateDummyAccountWithUsersConfig config = (CreateDummyAccountWithUsersConfig) context.loadConfigObject();
		
		try{
			
			ObjStore<CreateDummyAccountWithUsersConfig> store = ObjStoreHelper
					.getStore(CreateDummyAccountWithUsersConfig.class);

			List<CreateDummyAccountWithUsersConfig> list = store
					.query("accountName == '" + config.getAccountName() + "'");
			if (list == null || list.isEmpty()) {
				store.insert(config);
			} else {
				throw new Exception("account " + config.getAccountName() + " already exists.");
			}
			
			context.saveOutputValue(FooConstants.DUMMY_ACCOUNT_NAME_OUTPUT, config.getAccountName());
			context.saveOutputValue(FooConstants.DUMMY_ACCOUNT_IP_OUTPUT, config.getIp());
			context.saveOutputValue(FooConstants.DUMMY_ACCOUNT_STATUS_OUTPUT, config.getStatus());
			actionLogger.addInfo("DummyAccount with users "+config.getAccountName()+" added Successfully");
			
		} catch (Exception e) {
			
			logger.info("failed to Create Dummy Account with users", e);
		}
           }

    
	@Override
	public TaskConfigIf getTaskConfigImplementation() {
		return new CreateDummyAccountWithUsersConfig();
	}

	@Override
	public String getTaskName() {
		return CreateDummyAccountWithUsersConfig.HANDLER_NAME;//DummyAccount.MODIFY_HANDLER_NAME;
	}

	@Override
	public TaskOutputDefinition[] getTaskOutputDefinitions() {
		TaskOutputDefinition[] output = new TaskOutputDefinition[4];
		//NOTE: If you want to use the output of this task as input to another task. Then the second argument 
		//of the output definition MUST MATCH the type of UserInputField in the config of the task that will
		//be receiving this output.  Take a look at HelloWorldConfig as an example.
		output[0] = new TaskOutputDefinition(
				FooConstants.DUMMY_ACCOUNT_NAME_OUTPUT,
				WFFieldTypeConstants.GENERIC_TEXT,
				"Account Name");
		output[1] = new TaskOutputDefinition(
				"Status",
				WFFieldTypeConstants.GENERIC_TEXT,
				"Status");
		output[2] = new TaskOutputDefinition(
				"ip",
				WFFieldTypeConstants.GENERIC_TEXT,
				"ip");
		output[3] = new TaskOutputDefinition(
				"usersList",
				"usersListType",
				"usersList");
		return output;
	}

}
